## org.apache.commons.math.distribution
Class GammaDistributionImpl

    java.lang.Object
      org.apache.commons.math.distribution.AbstractDistribution
          org.apache.commons.math.distribution.AbstractContinuousDistribution
              org.apache.commons.math.distribution.GammaDistributionImpl

All Implemented Interfaces:
  Serializable, ContinuousDistribution, Distribution, GammaDistribution, HasDensity<Double>

    public class GammaDistributionImpl

extends AbstractContinuousDistribution
implements GammaDistribution, Serializable

The default implementation of `GammaDistribution`.

Version:
  $Revision: 1054524 $ $Date: 2011-01-03 05:59:18 +0100 (lun. 03 janv. 2011) $
See Also:
  Serialized Form

Field Summary
`private double` `alpha` The shape parameter.
`private double` `beta` The scale parameter.
`static double` `DEFAULT_INVERSE_ABSOLUTE_ACCURACY` Default inverse cumulative probability accuracy
`private static long` `serialVersionUID` Serializable version identifier
`private double` `solverAbsoluteAccuracy` Inverse cumulative probability accuracy

Fields inherited from class org.apache.commons.math.distribution.AbstractContinuousDistribution
`randomData`

Constructor Summary
`GammaDistributionImpl(double alpha, double beta)` Create a new gamma distribution with the given alpha and beta values.
`GammaDistributionImpl(double alpha, double beta, double inverseCumAccuracy)` Create a new gamma distribution with the given alpha and beta values.

Method Summary
`double` `cumulativeProbability(double x)` For this distribution, X, this method returns P(X < x).
`double` `density(double x)` Returns the probability density for a particular point.
`double` `density(Double x)` Deprecated.
`double` `getAlpha()` Access the shape parameter, alpha
`double` `getBeta()` Access the scale parameter, beta
`protected double` `getDomainLowerBound(double p)` Access the domain value lower bound, based on `p`, used to bracket a CDF root.
`protected double` `getDomainUpperBound(double p)` Access the domain value upper bound, based on `p`, used to bracket a CDF root.
`protected double` `getInitialDomain(double p)` Access the initial domain value, based on `p`, used to bracket a CDF root.
`double` `getNumericalMean()` Returns the mean.
`double` `getNumericalVariance()` Returns the variance.
`protected double` `getSolverAbsoluteAccuracy()` Return the absolute accuracy setting of the solver used to estimate inverse cumulative probabilities.
`double` `getSupportLowerBound()` Returns the upper bound of the support for the distribution.
`double` `getSupportUpperBound()` Returns the upper bound of the support for the distribution.
`double` `inverseCumulativeProbability(double p)` For this distribution, X, this method returns the critical point x, such that P(X < x) = `p`.
`void` `setAlpha(double alpha)` Deprecated. as of 2.1 (class will become immutable in 3.0)
`private void` `setAlphaInternal(double newAlpha)` Modify the shape parameter, alpha.
`void` `setBeta(double newBeta)` Deprecated. as of 2.1 (class will become immutable in 3.0)
`private void` `setBetaInternal(double newBeta)` Modify the scale parameter, beta.

Methods inherited from class org.apache.commons.math.distribution.AbstractContinuousDistribution
`reseedRandomGenerator, sample, sample`

Methods inherited from class org.apache.commons.math.distribution.AbstractDistribution
`cumulativeProbability`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.apache.commons.math.distribution.Distribution
`cumulativeProbability`

Field Detail

### DEFAULT_INVERSE_ABSOLUTE_ACCURACY

    public static final double DEFAULT_INVERSE_ABSOLUTE_ACCURACY

  Default inverse cumulative probability accuracy

  Since:
    2.1
  See Also:
    Constant Field Values

### serialVersionUID

    private static final long serialVersionUID

  Serializable version identifier

  See Also:
    Constant Field Values

### alpha

    private double alpha

  The shape parameter.

### beta

    private double beta

  The scale parameter.

### solverAbsoluteAccuracy

    private final double solverAbsoluteAccuracy

  Inverse cumulative probability accuracy

Constructor Detail

### GammaDistributionImpl

    public GammaDistributionImpl(double alpha,
                                 double beta)

  Create a new gamma distribution with the given alpha and beta values.

  Parameters:
    `alpha` - the shape parameter.
    `beta` - the scale parameter.

### GammaDistributionImpl

    public GammaDistributionImpl(double alpha,
                                 double beta,
                                 double inverseCumAccuracy)

  Create a new gamma distribution with the given alpha and beta values.

  Parameters:
    `alpha` - the shape parameter.
    `beta` - the scale parameter.
    `inverseCumAccuracy` - the maximum absolute error in inverse cumulative probability estimates (defaults to `DEFAULT_INVERSE_ABSOLUTE_ACCURACY`)
  Since:
    2.1

Method Detail

### cumulativeProbability

    public double cumulativeProbability(double x)
                                 throws MathException

  For this distribution, X, this method returns P(X < x). The implementation of this method is based on:
  - Chi-Squared Distribution, equation (9).
  - Casella, G., & Berger, R. (1990). Statistical Inference. Belmont, CA: Duxbury Press.

  Specified by:
    `cumulativeProbability` in interface `Distribution`
  Parameters:
    `x` - the value at which the CDF is evaluated.
  Returns:
    CDF for this distribution.
  Throws:
    `MathException` - if the cumulative probability can not be computed due to convergence or other numerical errors.

### inverseCumulativeProbability

    public double inverseCumulativeProbability(double p)
                                        throws MathException

  For this distribution, X, this method returns the critical point x, such that P(X < x) = `p`.

  Returns 0 for p=0 and `Double.POSITIVE_INFINITY` for p=1.

  Specified by:
    `inverseCumulativeProbability` in interface `ContinuousDistribution`
  Overrides:
    `inverseCumulativeProbability` in class `AbstractContinuousDistribution`
  Parameters:
    `p` - the desired probability
  Returns:
    x, such that P(X < x) = `p`
  Throws:
    `MathException` - if the inverse cumulative probability can not be computed due to convergence or other numerical errors.
    `IllegalArgumentException` - if `p` is not a valid probability.

### setAlpha

    @Deprecated
    public void setAlpha(double alpha)

  Deprecated. as of 2.1 (class will become immutable in 3.0)

  Modify the shape parameter, alpha.

  Specified by:
    `setAlpha` in interface `GammaDistribution`
  Parameters:
    `alpha` - the new shape parameter.
  Throws:
    `IllegalArgumentException` - if `alpha` is not positive.

### setAlphaInternal

    private void setAlphaInternal(double newAlpha)

  Modify the shape parameter, alpha.

  Parameters:
    `newAlpha` - the new shape parameter.
  Throws:
    `IllegalArgumentException` - if `newAlpha` is not positive.

### getAlpha

    public double getAlpha()

  Access the shape parameter, alpha

  Specified by:
    `getAlpha` in interface `GammaDistribution`
  Returns:
    alpha.

### setBeta

    @Deprecated
    public void setBeta(double newBeta)

  Deprecated. as of 2.1 (class will become immutable in 3.0)

  Modify the scale parameter, beta.

  Specified by:
    `setBeta` in interface `GammaDistribution`
  Parameters:
    `newBeta` - the new scale parameter.
  Throws:
    `IllegalArgumentException` - if `newBeta` is not positive.

### setBetaInternal

    private void setBetaInternal(double newBeta)

  Modify the scale parameter, beta.

  Parameters:
    `newBeta` - the new scale parameter.
  Throws:
    `IllegalArgumentException` - if `newBeta` is not positive.

### getBeta

    public double getBeta()

  Access the scale parameter, beta

  Specified by:
    `getBeta` in interface `GammaDistribution`
  Returns:
    beta.

### density

    public double density(double x)

  Returns the probability density for a particular point.

  Overrides:
    `density` in class `AbstractContinuousDistribution`
  Parameters:
    `x` - The point at which the density should be computed.
  Returns:
    The pdf at point x.

### density

    @Deprecated
    public double density(Double x)

  Deprecated.

  Return the probability density for a particular point.

  Specified by:
    `density` in interface `GammaDistribution`
  Specified by:
    `density` in interface `HasDensity<Double>`
  Parameters:
    `x` - The point at which the density should be computed.
  Returns:
    The pdf at point x.

### getDomainLowerBound

    protected double getDomainLowerBound(double p)

  Access the domain value lower bound, based on `p`, used to bracket a CDF root. This method is used by `inverseCumulativeProbability(double)` to find critical values.

  Specified by:
    `getDomainLowerBound` in class `AbstractContinuousDistribution`
  Parameters:
    `p` - the desired probability for the critical value
  Returns:
    domain value lower bound, i.e. P(X < lower bound) < `p`

### getDomainUpperBound

    protected double getDomainUpperBound(double p)

  Access the domain value upper bound, based on `p`, used to bracket a CDF root. This method is used by `inverseCumulativeProbability(double)` to find critical values.

  Specified by:
    `getDomainUpperBound` in class `AbstractContinuousDistribution`
  Parameters:
    `p` - the desired probability for the critical value
  Returns:
    domain value upper bound, i.e. P(X < upper bound) > `p`

### getInitialDomain

    protected double getInitialDomain(double p)

  Access the initial domain value, based on `p`, used to bracket a CDF root. This method is used by `inverseCumulativeProbability(double)` to find critical values.

  Specified by:
    `getInitialDomain` in class `AbstractContinuousDistribution`
  Parameters:
    `p` - the desired probability for the critical value
  Returns:
    initial domain value

### getSolverAbsoluteAccuracy

    protected double getSolverAbsoluteAccuracy()

  Return the absolute accuracy setting of the solver used to estimate inverse cumulative probabilities.

  Overrides:
    `getSolverAbsoluteAccuracy` in class `AbstractContinuousDistribution`
  Returns:
    the solver absolute accuracy
  Since:
    2.1

### getSupportLowerBound

    public double getSupportLowerBound()

  Returns the upper bound of the support for the distribution. The lower bound of the support is always 0, regardless of the parameters.

  Returns:
    lower bound of the support (always 0)
  Since:
    2.2

### getSupportUpperBound

    public double getSupportUpperBound()

  Returns the upper bound of the support for the distribution. The upper bound of the support is always positive infinity, regardless of the parameters.

  Returns:
    upper bound of the support (always Double.POSITIVE_INFINITY)
  Since:
    2.2

### getNumericalMean

    public double getNumericalMean()

  Returns the mean. For shape parameter `alpha` and scale parameter `beta`, the mean is `alpha * beta`

  Returns:
    the mean
  Since:
    2.2

### getNumericalVariance

    public double getNumericalVariance()

  Returns the variance. For shape parameter `alpha` and scale parameter `beta`, the variance is `alpha * beta^2`

  Returns:
    the variance
  Since:
    2.2

Copyright (c) 2003-2013 Apache Software Foundation